import { Unsubscribe } from './subscriptions';
export declare type Listener<T> = (colletion: Collection<T>, change: Change<T>) => void;
export interface Entries<T> {
    [key: string]: T | undefined;
}
export interface CollectionMethods<T> {
    subscribe(listener: Listener<Collection<T>>): Unsubscribe;
    unsubscribe(onUpdate: Listener<Collection<T>>): void;
    toArray(): T[];
}
export declare type Collection<T> = Entries<T> & CollectionMethods<Entries<T>>;
export interface Change<T> {
    id: string;
    change: 'set' | 'delete';
    entry: T;
}
export declare function createCollection<T>(entries?: Entries<T>): Collection<T>;
